/**
 *  \file Server.h
 *
 *  $LastChangedBy: sjk114 $
 *  $Date: 2010-08-19 16:35:44 +1200 (Thu, 19 Aug 2010) $
 *
 */

#ifndef SERVER_H
#define SERVER_H

#include "ServerSocket.h"
#include "Inbox.h"
#include "ListenerSocket.h"

class Server {
public:
  /**
   *  \brief Create a ChatManager, UserManager and ListenerSocket and run the 
   *         ListenerSocket thread.
   */
  Server();
  ~Server(){};
  
  /**
   *  \brief Create a new ServerSocket, Inbox and Outbox and start the Inbox 
   *         thread.
   *  \param connection_id the socket file descriptor
   */
  void newConnection(int connection_id);
  
private:
  ChatManager chat_manager;
  UserManager user_manager;
  ListenerSocket listener_socket;
  std::list<Inbox*> clients;
};

#endif /* SERVER_H */
